/*
 * Created on 2004/06/01
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kidnapping;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;
import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

import org.boxed_economy.besp.model.fmfw.behavior.Action;

import org.boxed_economy.besp.model.fmfw.TimeEvent;

/**
* AbstractKimBehavior
*/
public abstract class AbstractKimBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState waitingForKoizumi =
			factory.createCompositeState("WaitingForKoizumi");
		CompositeState waitingForAskedNumber =
			factory.createCompositeState("WaitingForAskedNumber");
		CompositeState waitingForRequest =
			factory.createCompositeState("WaitingForRequest");
		CompositeState waitingForNewRequest =
			factory.createCompositeState("WaitingForNewRequest");
		CompositeState waitingForThankYou =
			factory.createCompositeState("WaitingForThankYou");
		CompositeState waitingForInsentive =
			factory.createCompositeState("WaitingForInsentive");
		State terminalState = factory.createTerminalState();

		//actions
		Action greetingAction = new Action() {
			public void doAction() {
				greetingAction();
			}
			public String toString() {
				return "greetingAction";
			}
		};
		Action sayingOkAction = new Action() {
			public void doAction() {
				sayingOkAction();
			}
			public String toString() {
				return "sayingOkAction";
			}
		};
		Action givingVictimsAction = new Action() {
			public void doAction() {
				givingVictimsAction();
			}
			public String toString() {
				return "givingVictimsAction";
			}
		};
		Action sayingNoAction = new Action() {
			public void doAction() {
				sayingNoAction();
			}
			public String toString() {
				return "sayingNoAction";
			}
		};
		Action recievingInsentiveAction = new Action() {
			public void doAction() {
				recievingInsentiveAction();
			}
			public String toString() {
				return "recievingInsentiveAction";
			}
		};
		Action sayingHowManyAction = new Action() {
			public void doAction() {
				sayingHowManyAction();
			}
			public String toString() {
				return "sayingHowManyAction";
			}
		};

		//guard-conditions

		//transitions
		Transition transitionWaitingForThankYouToWaitingForInsentive =
			factory.createTransition();
		Transition transitionWaitingForNewRequestToWaitingForThankYou =
			factory.createTransition();
		Transition transitionWaitingForAskedNumberToWaitingForRequest =
			factory.createTransition();
		Transition transitionInitialStateToWaitingForKoizumi =
			factory.createTransition();
		Transition transitionWaitingForInsentiveToTerminalState =
			factory.createTransition();
		Transition transitionWaitingForKoizumiToWaitingForAskedNumber =
			factory.createTransition();
		Transition transitionWaitingForRequestToWaitingForNewRequest =
			factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(waitingForKoizumi);
		this.addState(waitingForAskedNumber);
		this.addState(waitingForRequest);
		this.addState(waitingForNewRequest);
		this.addState(waitingForThankYou);
		this.addState(waitingForInsentive);
		this.addTerminalState(terminalState);

		//transitions setting
		transitionWaitingForThankYouToWaitingForInsentive.setEvent(
			TimeEvent.class);
		transitionWaitingForThankYouToWaitingForInsentive.addAction(
			givingVictimsAction);
		transitionWaitingForNewRequestToWaitingForThankYou.setEvent(
			ChannelEvent.class);
		transitionWaitingForNewRequestToWaitingForThankYou.addAction(
			sayingOkAction);
		transitionWaitingForAskedNumberToWaitingForRequest.setEvent(
			ChannelEvent.class);
		transitionWaitingForAskedNumberToWaitingForRequest.addAction(
			sayingHowManyAction);
		transitionWaitingForInsentiveToTerminalState.setEvent(
			ChannelEvent.class);
		transitionWaitingForInsentiveToTerminalState.addAction(
			recievingInsentiveAction);
		transitionWaitingForKoizumiToWaitingForAskedNumber.setEvent(
			ChannelEvent.class);
		transitionWaitingForKoizumiToWaitingForAskedNumber.addAction(
			greetingAction);
		transitionWaitingForRequestToWaitingForNewRequest.setEvent(
			ChannelEvent.class);
		transitionWaitingForRequestToWaitingForNewRequest.addAction(
			sayingNoAction);

		//connection of transitions
		transitionWaitingForThankYouToWaitingForInsentive.setSourceState(
			waitingForThankYou);
		transitionWaitingForThankYouToWaitingForInsentive.setTargetState(
			waitingForInsentive);
		transitionWaitingForNewRequestToWaitingForThankYou.setSourceState(
			waitingForNewRequest);
		transitionWaitingForNewRequestToWaitingForThankYou.setTargetState(
			waitingForThankYou);
		transitionWaitingForAskedNumberToWaitingForRequest.setSourceState(
			waitingForAskedNumber);
		transitionWaitingForAskedNumberToWaitingForRequest.setTargetState(
			waitingForRequest);
		transitionInitialStateToWaitingForKoizumi.setSourceState(initialState);
		transitionInitialStateToWaitingForKoizumi.setTargetState(
			waitingForKoizumi);
		transitionWaitingForInsentiveToTerminalState.setSourceState(
			waitingForInsentive);
		transitionWaitingForInsentiveToTerminalState.setTargetState(
			terminalState);
		transitionWaitingForKoizumiToWaitingForAskedNumber.setSourceState(
			waitingForKoizumi);
		transitionWaitingForKoizumiToWaitingForAskedNumber.setTargetState(
			waitingForAskedNumber);
		transitionWaitingForRequestToWaitingForNewRequest.setSourceState(
			waitingForRequest);
		transitionWaitingForRequestToWaitingForNewRequest.setTargetState(
			waitingForNewRequest);

	}

	/**
	*greetingAction
	*/
	protected abstract void greetingAction();
	/**
	*sayingOkAction
	*/
	protected abstract void sayingOkAction();
	/**
	*givingVictimsAction
	*/
	protected abstract void givingVictimsAction();
	/**
	*sayingNoAction
	*/
	protected abstract void sayingNoAction();
	/**
	*recievingInsentiveAction
	*/
	protected abstract void recievingInsentiveAction();
	/**
	*sayingHowManyAction
	*/
	protected abstract void sayingHowManyAction();
}
