/*
 * Created on 2004/06/01
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kidnapping;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.TimeEvent;
import org.boxed_economy.besp.model.fmfw.behavior.Action;
import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;

import org.boxed_economy.besp.model.fmfw.behavior.Event;
import org.boxed_economy.besp.model.fmfw.behavior.GuardCondition;

/**
* AbstractKoizumiBehavior
*/
public abstract class AbstractKoizumiBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState waitingForTime =
			factory.createCompositeState("WaitingForTime");
		CompositeState waitingForReply =
			factory.createCompositeState("WaitingForReply");
		CompositeState waitingForNumber =
			factory.createCompositeState("WaitingForNumber");
		CompositeState waitingForAnswer =
			factory.createCompositeState("WaitingForAnswer");
		CompositeState waitingForNewAnswer =
			factory.createCompositeState("WaitingForNewAnswer");
		CompositeState waitingForVictims =
			factory.createCompositeState("WaitingForVictims");
		State terminalState = factory.createTerminalState();

		//actions
		Action givingNewDemandAction = new Action() {
			public void doAction() {
				givingNewDemandAction();
			}
			public String toString() {
				return "givingNewDemandAction";
			}
		};
		Action askingNumberAction = new Action() {
			public void doAction() {
				askingNumberAction();
			}
			public String toString() {
				return "askingNumberAction";
			}
		};
		Action givingInsentive = new Action() {
			public void doAction() {
				givingInsentive();
			}
			public String toString() {
				return "givingInsentive";
			}
		};
		Action givingDemand = new Action() {
			public void doAction() {
				givingDemand();
			}
			public String toString() {
				return "givingDemand";
			}
		};
		Action sayingThankYouEvent = new Action() {
			public void doAction() {
				sayingThankYouEvent();
			}
			public String toString() {
				return "sayingThankYouEvent";
			}
		};
		Action sayingHelloAction = new Action() {
			public void doAction() {
				sayingHelloAction();
			}
			public String toString() {
				return "sayingHelloAction";
			}
		};
		Action receivingVictimsAction = new Action() {
			public void doAction() {
				receivingVictimsAction();
			}
			public String toString() {
				return "receivingVictimsAction";
			}
		};

		//guard-conditions
		GuardCondition isKidnappInformation = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isKidnappInformation(e);
			}
		};

		//transitions
		Transition transitionWaitingForNumberToWaitingForAnswer =
			factory.createTransition();
		Transition transitionWaitingForReplyToWaitingForNumber =
			factory.createTransition();
		Transition transitionInitialStateToWaitingForTime =
			factory.createTransition();
		Transition transitionWaitingForAnswerToWaitingForNewAnswer =
			factory.createTransition();
		Transition transitionWaitingForVictimsToTerminalState =
			factory.createTransition();
		Transition transitionWaitingForNewAnswerToWaitingForVictims =
			factory.createTransition();
		Transition transitionWaitingForTimeToWaitingForReply =
			factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(waitingForTime);
		this.addState(waitingForReply);
		this.addState(waitingForNumber);
		this.addState(waitingForAnswer);
		this.addState(waitingForNewAnswer);
		this.addState(waitingForVictims);
		this.addTerminalState(terminalState);

		//transitions setting
		transitionWaitingForNumberToWaitingForAnswer.setEvent(
			ChannelEvent.class);
		transitionWaitingForNumberToWaitingForAnswer.setGuardCondition(
			isKidnappInformation);
		transitionWaitingForNumberToWaitingForAnswer.addAction(givingDemand);
		transitionWaitingForReplyToWaitingForNumber.setEvent(
			ChannelEvent.class);
		transitionWaitingForReplyToWaitingForNumber.addAction(
			askingNumberAction);
		transitionWaitingForAnswerToWaitingForNewAnswer.setEvent(
			TimeEvent.class);
		transitionWaitingForAnswerToWaitingForNewAnswer.addAction(
			givingNewDemandAction);
		transitionWaitingForVictimsToTerminalState.setEvent(ChannelEvent.class);
		transitionWaitingForVictimsToTerminalState.addAction(
			receivingVictimsAction);
		transitionWaitingForVictimsToTerminalState.addAction(givingInsentive);
		transitionWaitingForNewAnswerToWaitingForVictims.setEvent(
			ChannelEvent.class);
		transitionWaitingForNewAnswerToWaitingForVictims.addAction(
			sayingThankYouEvent);
		transitionWaitingForTimeToWaitingForReply.setEvent(TimeEvent.class);
		transitionWaitingForTimeToWaitingForReply.addAction(sayingHelloAction);

		//connection of transitions
		transitionWaitingForNumberToWaitingForAnswer.setSourceState(
			waitingForNumber);
		transitionWaitingForNumberToWaitingForAnswer.setTargetState(
			waitingForAnswer);
		transitionWaitingForReplyToWaitingForNumber.setSourceState(
			waitingForReply);
		transitionWaitingForReplyToWaitingForNumber.setTargetState(
			waitingForNumber);
		transitionInitialStateToWaitingForTime.setSourceState(initialState);
		transitionInitialStateToWaitingForTime.setTargetState(waitingForTime);
		transitionWaitingForAnswerToWaitingForNewAnswer.setSourceState(
			waitingForAnswer);
		transitionWaitingForAnswerToWaitingForNewAnswer.setTargetState(
			waitingForNewAnswer);
		transitionWaitingForVictimsToTerminalState.setSourceState(
			waitingForVictims);
		transitionWaitingForVictimsToTerminalState.setTargetState(
			terminalState);
		transitionWaitingForNewAnswerToWaitingForVictims.setSourceState(
			waitingForNewAnswer);
		transitionWaitingForNewAnswerToWaitingForVictims.setTargetState(
			waitingForVictims);
		transitionWaitingForTimeToWaitingForReply.setSourceState(
			waitingForTime);
		transitionWaitingForTimeToWaitingForReply.setTargetState(
			waitingForReply);

	}

	/**
	*givingNewDemandAction
	*/
	protected abstract void givingNewDemandAction();
	/**
	*askingNumberAction
	*/
	protected abstract void askingNumberAction();
	/**
	*givingInsentive
	*/
	protected abstract void givingInsentive();
	/**
	*givingDemand
	*/
	protected abstract void givingDemand();
	/**
	*sayingThankYouEvent
	*/
	protected abstract void sayingThankYouEvent();
	/**
	*sayingHelloAction
	*/
	protected abstract void sayingHelloAction();
	/**
	*receivingVictimsAction
	*/
	protected abstract void receivingVictimsAction();
	/**
	*isKidnappInformation
	*/
	protected abstract boolean isKidnappInformation(Event e);
}
